#include <mpi.h>
#include "data.h"

void OnVarDef(int size, void *pTop, int count);
//-----------------------------------------------------------------------------------------------------------
// for structs
void OnStructDef(STRUCT name,int size,int ptrCount,int ptrDisp[],int strCount, int strDisp[],STRUCT strName[]);
void OnStructVarDef(STRUCT name,void *pTop,int count);

//-------------------------------------------------------------------------------------------------------------
// for pointer
void OnPtrDef(void *ptr,int count);

//--------------------------------------------------------------------------------------------------------------
// for function pointer
void OnFuncDef(void *func);

//--------------------------------------------------------------------------------------------------
//for typedef
void OnTypePtrDef(char *pTypePtrName);
void OnTypeOtherDef(char pOldName[STRUCT_NAME_20],char pNewName[STRUCT_NAME_20]);
void OnTypeVarDef(char pTypeName[STRUCT_NAME_20],int size,void *pTop,int count);

void *ELC_malloc(int size);
void *ELC_calloc(int nmemb, int size);
void *ELC_realloc(void *ptr, int size);
void ELC_free(void *ptr);

//-----------------------------------------------------------------------------------------------------
// for struct defined in the heap allocation
//-----------------------------------------------------------------------------------------------------
void OnHeapDef(STRUCT name, void *pTop, int count);

//-----------------------------------------------------------------------------------------------------------
// for type defined in the heap allocation
//-----------------------------------------------------------------------------------------------------------
void OnTypeHeapDef(char pTypeName[STRUCT_NAME_20],int size,void *pTop,int count);

void OnCallEnter(int Tag,int fNum);
void OnCallReturn();

void CKPT_Init();

int ELC_MPI_Send(void *buf,int count,MPI_Datatype datatype,int target,int tag,MPI_Comm comm);
int ELC_MPI_Recv(void *buf,int count,MPI_Datatype datatype,int source,int tag,MPI_Comm comm,MPI_Status *pStatus);

int ELC_MPI_Init(int *argc,char ***argv);
int ELC_MPI_Finalize();

int ELC_MPI_Type_commit(MPI_Datatype *pDatatype);
int ELC_MPI_Type_free(MPI_Datatype *pDatatype);

int ELC_MPI_Comm_dup(MPI_Comm comm,MPI_Comm *pComm);