
#include "mpi.h"
#include "libELC.h"
//----------------------------------------------------------------------------------------------------------
// for all heap allocation
void *ELC_malloc(int size)
{
   struct HEAP *heapTemp;
   
   heapTemp=(void *)malloc(g_HEAP_SIZE);
//   heapTemp->ptrHead=(struct POINTER *)malloc(g_POINTER_SIZE);
//   heapTemp->ptrHead->pre=NULL;
 //  heapTemp->ptrHead->next==NULL;
//   heapTemp->ptrTail=heapTemp->ptrHead;

   heapTemp->pTop=(void *)malloc(size);
   heapTemp->pBottom=heapTemp->pTop+(size-1);
   
   heapTemp->size=size;
   heapTemp->ptrCount=0;
   heapTemp->ptrDisp=NULL;
   heapTemp->next=NULL;
   heapTemp->pre=g_heapTail;
 
   g_heapTail->next=heapTemp;
   g_heapTail=heapTemp;

   g_flowTail->heapCount++;

   return heapTemp->pTop;
}

void ELC_free(void *ptr)
{
	struct HEAP *heapTemp=g_heapHead->next;
//	struct POINTER *t_ptrTemp;

	if (ptr==NULL)
	{
		return;
	}

	while (heapTemp!=NULL)
	{
		if (heapTemp->pTop==ptr)
		{
			heapTemp->pre->next=heapTemp->next;
			if (heapTemp->next!=NULL)
			{
				heapTemp->next->pre=heapTemp->pre;
			}
			else {
				g_heapTail=heapTemp->pre;
			}

			free(ptr);
			free(heapTemp->ptrDisp);		// release ptrHead;
			free(heapTemp);
		    
			break;
		}
		heapTemp=heapTemp->next;
	}
	
	g_flowTail->heapCount--;
	return;
}

void *ELC_calloc(int nmemb, int size)
{
   struct HEAP *heapTemp;

   heapTemp=(void *)malloc(g_HEAP_SIZE);
   //heapTemp->ptrHead=(struct POINTER *)malloc(g_POINTER_SIZE);
   //heapTemp->ptrHead->pre=NULL;
  // heapTemp->ptrHead->next==NULL;
 //  heapTemp->ptrTail=heapTemp->ptrHead;

   heapTemp->pTop=(void *)calloc(nmemb, size);
   heapTemp->pBottom=heapTemp->pTop+nmemb*size-1;
   heapTemp->size=nmemb*size;
   heapTemp->next=NULL;

   heapTemp->pre=g_heapTail;
   g_heapTail->next=heapTemp;
   g_heapTail=heapTemp;

   g_flowTail->heapCount++;

   return heapTemp->pTop;
}

void *ELC_realloc(void *ptr, int size)
{
	struct HEAP *heapTemp;
    void *pHeap;

    if (size==0)
    {
        heapTemp=g_heapHead;

		while (heapTemp!=NULL)
		{
			if (heapTemp->pTop==ptr)
			{
				heapTemp->pre->next=heapTemp->next;
				heapTemp->next->pre=heapTemp->pre;

				free(heapTemp->pTop);
				free(heapTemp->pBottom);
				free(heapTemp);
			    
				break;
			}
			heapTemp=heapTemp->next;
		}
	    return (NULL);
    }

    pHeap=(void *)malloc(size);

	if (pHeap==NULL)
	{
		return (NULL);
	}

	if (ptr==NULL)
	{
       heapTemp=(void *)malloc(g_HEAP_SIZE);

	   heapTemp->pTop=pHeap;
	   heapTemp->pBottom=heapTemp->pTop+size-1;
	   heapTemp->size=size;

	   heapTemp->pre=g_heapTail;
       g_heapTail->next=heapTemp;
	   g_heapTail=heapTemp;

	   return heapTemp->pTop;
	}
    
	heapTemp=g_heapHead;
	while (heapTemp!=NULL)
	{
		if (heapTemp->pTop==ptr)
		{
			free(heapTemp->pTop);
			heapTemp->pTop=(void *)malloc(size);
            heapTemp->pBottom=heapTemp->pTop+size-1;
			heapTemp->size=size;
					    
			break;
		}
        heapTemp=heapTemp->next;
	}
	return heapTemp->pTop;
}

//-----------------------------------------------------------------------------------------------------
// for struct defined in the heap allocation
//-----------------------------------------------------------------------------------------------------
void OnHeapDef(STRUCT name, void *pTop, int count)
{
   int i,j;
   struct STRUCTS *struTemp=g_struHead->next;
   struct POINTER *ptrTemp;

   while (struTemp!=NULL){
	  if (!strcmp(struTemp->name,name)) break;
      struTemp=struTemp->next;
   }
   if (struTemp==NULL) return;

   g_heapTail->ptrCount=count*struTemp->ptrCount;
   g_heapTail->ptrDisp=(int *)malloc(g_INT_SIZE*g_heapTail->ptrCount);
   for (j=0;j<count;j++)
   {
	   for (i=0;i<struTemp->ptrCount;i++)
	   {
		    g_heapTail->ptrDisp[i+j*struTemp->ptrCount]=struTemp->ptrDisp[i]+j*(struTemp->size-1);

			//ptrTemp=(struct POINTER *)malloc(g_POINTER_SIZE);
			//ptrTemp->pTarget=pTop+*(g_heapTail->ptrDisp+i);
			//ptrTemp->prop=NULLS;

			//ptrTemp->pre=g_heapTail->ptrTail;
			//ptrTemp->next=NULL;
			//g_heapTail->ptrTail=ptrTemp;
	   }
   }
   
   return;
}

//-----------------------------------------------------------------------------------------------------------
// for type defined in the heap allocation
//-----------------------------------------------------------------------------------------------------------
void OnTypeHeapDef(char pTypeName[STRUCT_NAME_20],int size,void *pTop,int count)
{
	struct STRUCTS *struTemp=g_struHead->next;

	// structure
	while (struTemp!=NULL)
	{
		if (strstr(struTemp->pAlias,pTypeName)!=NULL)
		{
			OnHeapDef(struTemp->name,pTop,count*(size/struTemp->size));
			return;
		}
		struTemp=struTemp->next;
	}
	
	// otherwise
	return;
}

/*void OnTypeHeapDef(char pTypeName[STRUCT_NAME_20],int size,void *pTop,int count)
{
	struct STRUCTS	*t_struTemp=g_struHead->next;
	char *pAlias,*pName;

	while (t_struTemp!=NULL)
	{
		pAlias=t_struTemp->pAlias;
		// found the string in struct's aliases
		if (strstr(pAlias,pTypeName)!=NULL)
		{
			//OnStructVarDef(t_struTemp->pName,pTop,count*(size/t_struTemp->total_size));
			pName=t_struTemp->pStructName;
			while (count-->0)
			{
				for (i=0;i<t_struTemp->count;i++)
				{
					switch(CharMapping(pName))
				    {
						case (-1):
							break;
						case (0):
							OnPtrDef(pTop+*(t_struTemp->pDisp+i),size/g_PTR_SIZE*count);
							break;
						default:
							OnStructVarDef(pName,pTop+*(t_struTemp->pDisp+i),*(t_struTemp->pLength+i)*size/t_struTemp->total_size);	
					}  
			   }
		   }
			return;
		}
		t_struTemp=t_struTemp->next;
	}

	// found the string in the pointer's string
	if (strstr(g_TYPE_PTR_NAME,pTypeName)!=NULL)
	{
		OnPtrDef(&pTop,count*size/g_PTR_SIZE);
		return;
	}
	// otherwise, it's a common variable
	// OnVarDef(size,pTop,count);

	return;
}
*/

