
#include "mpi.h"
#include "libELC.h"
// === var.c ===
extern void OnPtrDef(void *ptr,int count);
extern void OnPtrCKPT();
extern void OnReturnVar(int count);
extern void OnReturnPtr(int count);

// === heap.c ===
extern void *ELC_malloc(int size);

// === msg.c ===
extern void Value2Type(struct MSG *t_msgTemp);
extern void Value2Comm(struct MSG *t_msgTemp);

//-----------------------------------------------------------------------------------------------------------------

void DoCKPT(int Tag,int fNum)
{	
	if (g_RECOVER_FLAG==NO)
	{
		g_CKPT_FLAG=YES;
		OnCallEnter(Tag,fNum);
		SaveVar();
		SaveHeap();
		SavePtr();
		SaveFlow();
	
		//SaveMPI();
		OnCKPT();
		printf("checkpoint done %d\n",g_MYRANK);
	}
	else 
	{
		RecoverVar();
		RecoverHeap();
		RecoverPtr();
		//RecoverMSG();
		//RecoverLOG();
		//RecoverMPI();		
	
		printf("%d recovers DONE\n",g_MYRANK);

	}
//	OnCallReturn();	
	

}

// for var -----------------------------------------------------------------------------------------------------
void SaveVar()
{
	FILE *f_VarHandler;
	struct VAR *t_varTemp=g_varHead->next;

	f_VarHandler=fopen(g_f_VarName,"wb");
	while (t_varTemp!=NULL)
	{
		fwrite(t_varTemp->pTop,t_varTemp->size,t_varTemp->count,f_VarHandler);

		t_varTemp=t_varTemp->next;
	}
	fclose(f_VarHandler);

	return;
}

void RecoverVar()
{
	struct VAR *t_varTemp=g_varHead->next;
	FILE *f_VarHandler;

	f_VarHandler=fopen(g_f_VarName,"rb");
	
	while (t_varTemp!=NULL)
	{
		fread(t_varTemp->pTop,t_varTemp->size,t_varTemp->count,f_VarHandler);
		t_varTemp=t_varTemp->next;
	}
	fclose(f_VarHandler);	
	return;
}

//----------------------------------------------------------------------------------------------------------------
// for heap

void SaveHeap()
{
	int i;
	FILE *f_HeapHandler;
	struct HEAP *t_heapTemp=g_heapHead->next;
	struct POINTER *t_ptrTemp=(struct POINTER *)malloc(g_POINTER_SIZE);

	f_HeapHandler=fopen(g_f_HeapName,"wb");

	while (t_heapTemp!=NULL)
	{
		fwrite(&(t_heapTemp->size),g_INT_SIZE,1,f_HeapHandler);					// the heap size
		fwrite(&(t_heapTemp->ptrCount),g_INT_SIZE,1,f_HeapHandler);				// the number of pointers
		fwrite(t_heapTemp->ptrDisp,g_INT_SIZE,t_heapTemp->ptrCount,f_HeapHandler);				// the disps of pointers
		fwrite(t_heapTemp->pTop,g_BYTE_SIZE,t_heapTemp->size,f_HeapHandler);	// the heap content
		
		// save the heap pointer

		for (i=0;i<t_heapTemp->ptrCount;i++)
		{

			t_ptrTemp->pTarget=t_heapTemp->pTop+t_heapTemp->ptrDisp[i];
			PtrSeek(t_ptrTemp);

			fwrite(&(t_ptrTemp->prop),g_INT_SIZE,1,f_HeapHandler);
			fwrite(&(t_ptrTemp->seq),g_INT_SIZE,1,f_HeapHandler);
			fwrite(&(t_ptrTemp->offset),g_LONG_SIZE,1,f_HeapHandler);
		}
		t_heapTemp=t_heapTemp->next;
	}
	fclose(f_HeapHandler);

	return;
}

void RecoverHeap()
{
	FILE *f_HeapHandler;
	void *pTemp;								//used for the return of allocation function
	int i,size;
	struct POINTER *t_ptrTemp;
	struct VAR *t_varTemp=g_varHead->next;
	struct HEAP *t_heapTemp=g_heapHead->next;
	struct POINTER *t_ptrT=g_ptrHead->next;
	struct FUNC *t_addrTemp=g_funcHead->next;

	f_HeapHandler=fopen(g_f_HeapName,"rb");

	while (!feof(f_HeapHandler))
	{
		if (fread(&size,g_INT_SIZE,1,f_HeapHandler)!=1) break;
		pTemp=(void *)ELC_malloc(size);										// realloc the heap & create the heap record
		
		fread(&(g_heapTail->ptrCount),g_INT_SIZE,1,f_HeapHandler);			
		g_heapTail->ptrDisp=(int *)malloc(g_INT_SIZE*t_heapTemp->ptrCount);
		fread(g_heapTail->ptrDisp,g_INT_SIZE,g_heapTail->ptrCount,f_HeapHandler);			

		fread(pTemp,g_BYTE_SIZE,size,f_HeapHandler);
		
		i=0;
		t_ptrTemp=g_heapTail->ptrHead;
		while (i<g_heapTail->ptrCount)
		{
			fread(&(t_ptrTemp->prop),g_INT_SIZE,1,f_HeapHandler);
			fread(&(t_ptrTemp->seq),g_INT_SIZE,1,f_HeapHandler);
			fread(&(t_ptrTemp->offset),g_LONG_SIZE,1,f_HeapHandler);

			switch (t_ptrTemp->prop)
			{
				case (VAR):{
					while (i<t_ptrTemp->seq)
					{
						t_varTemp=t_varTemp->next;
						i++;
					}
					*(t_ptrTemp->pTarget)=t_varTemp->pTop+t_ptrTemp->offset;	//restore the pointer
					break;
				}
				case (HEAP): {
					while (i<t_ptrTemp->seq)
					{
						t_heapTemp=t_heapTemp->next;
						i++;
					}
					*(t_ptrTemp->pTarget)=t_heapTemp->pTop+t_ptrTemp->offset;	//restore the pointer
					break;
				}
				case (FUNC): {
					while (i<t_ptrTemp->seq)
					{
						t_addrTemp=t_addrTemp->next;
						i++;
					}
					*(t_ptrTemp->pTarget)=t_addrTemp->func;	//restore the pointer
					break;
				}
				// problem
				case (PTR):	{
					while (i<t_ptrTemp->seq)
					{
						t_ptrT=t_ptrT->next;
						i++;
					}
					*(t_ptrTemp->pTarget)=t_ptrT->pTarget+t_ptrTemp->offset;	//restore the pointer
					break;
				}
				t_ptrTemp=t_ptrTemp->next;
			}	
		}

	}
	fclose(f_HeapHandler);
	return;
}

//-----------------------------------------------------------------------------------------------------------------
// for pointer

void SavePtr()
{
	int i=0;
	FILE *f_PtrHandler;
	struct POINTER *t_ptrTemp=g_ptrHead->next;

	OnPtrCKPT();
	f_PtrHandler=fopen(g_f_PtrName,"wb");

	while (t_ptrTemp!=NULL)
	{
		PtrSeek(t_ptrTemp);

		fwrite(&(t_ptrTemp->prop),g_INT_SIZE,1,f_PtrHandler);
		fwrite(&(t_ptrTemp->seq),g_INT_SIZE,1,f_PtrHandler);
		fwrite(&(t_ptrTemp->offset),g_LONG_SIZE,1,f_PtrHandler);

		i++;
		t_ptrTemp=t_ptrTemp->next;
	}

	fclose(f_PtrHandler);
	return;
}

void RecoverPtr()
{
	int i=1;
	FILE *f_PtrHandler;
	struct POINTER *t_ptrTemp=g_ptrHead->next;
	struct POINTER *t_ptrT=g_ptrHead->next;
	struct VAR *t_varTemp=g_varHead->next;
	struct HEAP *t_heapTemp=g_heapHead->next;
	struct FUNC *t_addrTemp=g_funcHead->next;
	
	f_PtrHandler=fopen(g_f_PtrName,"rb");

	while (t_ptrTemp!=NULL)
	{
		fread(&(t_ptrTemp->prop),g_INT_SIZE,1,f_PtrHandler);
		fread(&(t_ptrTemp->seq),g_INT_SIZE,1,f_PtrHandler);
		fread(&(t_ptrTemp->offset),g_LONG_SIZE,1,f_PtrHandler);
		
		switch (t_ptrTemp->prop)
		{
			case (VAR):{
				while (i<t_ptrTemp->seq)
				{
					t_varTemp=t_varTemp->next;
					i++;
				}
				*(t_ptrTemp->pTarget)=t_varTemp->pTop+t_ptrTemp->offset;	//restore the pointer
				break;
			}
			case (HEAP): {
				while (i<t_ptrTemp->seq)
				{
					t_heapTemp=t_heapTemp->next;
					i++;
				}
				*(t_ptrTemp->pTarget)=t_heapTemp->pTop+t_ptrTemp->offset;	//restore the pointer
				break;
			}
			case (FUNC): {
				while (i<t_ptrTemp->seq)
				{
					t_addrTemp=t_addrTemp->next;
					i++;
				}
				*(t_ptrTemp->pTarget)=t_addrTemp->func;	//restore the pointer
				break;
			}
			// problem
			case (PTR):	{
				while (i<t_ptrTemp->seq)
				{
					t_ptrTemp=t_ptrTemp->next;
					i++;
				}
				*(t_ptrTemp->pTarget)=t_ptrT->pTarget+t_ptrTemp->offset;	//restore the pointer
				break;
			}
		}
		t_ptrTemp=t_ptrTemp->next;
	}
	fclose(f_PtrHandler);
	return;
}

//---------------------------------------------------------------------------------------------------------------
// for flow

void SaveFlow()
{
	FILE *f_FlowHandler;
	struct FLOW *t_flowTemp=g_flowHead->next;
	struct SUBFLOW *t_subTemp;

	f_FlowHandler=fopen(g_f_FlowName,"wb");

	while (t_flowTemp!=NULL)
	{
		fwrite(&(t_flowTemp->Tag),g_INT_SIZE,1,f_FlowHandler);	
		fwrite(&(t_flowTemp->fNum),g_INT_SIZE,1,f_FlowHandler);
		fwrite(&(t_flowTemp->subCount),g_INT_SIZE,1,f_FlowHandler);

		t_flowTemp=t_flowTemp->next;
	}

	fclose(f_FlowHandler);

	return;
}

void RecoverFlow()
{
	int i;
	FILE *f_FlowHandler;
	struct FLOW *t_flowTemp;
	struct SUBFLOW *t_subTemp;
	{
	};

	f_FlowHandler=fopen(g_f_FlowName,"rb");
	while (!feof(f_FlowHandler))
	{
		fread(&(t_flowTemp->Tag),g_INT_SIZE,1,f_FlowHandler);
		fread(&(t_flowTemp->fNum),g_INT_SIZE,1,f_FlowHandler);

		g_flowTail->next=t_flowTemp;
		t_flowTemp->pre=g_flowTail;
		t_flowTemp->next=NULL;
		g_flowTail=t_flowTemp;
	}
	fclose(f_FlowHandler);
	g_flowTail=g_flowHead->next;

	return;
}

// ------------------------------------------------------------------------------------------------------------

void SaveMSG()
{
	int ierr,size;
	struct LIST *t_listTemp=g_listHead->next;
	struct MSG *t_earlyTemp;
	FILE *f_earlyHandler;

	f_earlyHandler=fopen(g_f_MsgName,"wb");

	while (t_listTemp!=NULL)
	{
		if (t_listTemp->rank==g_MYRANK) t_listTemp=t_listTemp->next;

		// write early event log to file
		t_earlyTemp=t_listTemp->msgHead[3]->next;
		while (t_earlyTemp!=NULL)
		{
			fwrite(&(t_listTemp->rank),g_INT_SIZE,1,f_earlyHandler);		
			fwrite(&(t_earlyTemp->count),g_INT_SIZE,1,f_earlyHandler);
			fwrite(&(t_earlyTemp->tag),g_INT_SIZE,1,f_earlyHandler);
			fwrite(&(t_earlyTemp->typeValue),g_INT_SIZE,1,f_earlyHandler);
			fwrite(&(t_earlyTemp->commValue),g_INT_SIZE,1,f_earlyHandler);

			t_earlyTemp=t_earlyTemp->next;
		}
		t_listTemp=t_listTemp->next;
	}

	fclose(f_earlyHandler);
	return;
}

void RecoverMSG()
{
	int ierr,size,source;
	struct LIST *t_listTemp;
	struct MSG *t_msgTemp;
	FILE *f_earlyHandler;

	f_earlyHandler=fopen(g_f_MsgName,"wb");
	if (f_earlyHandler==NULL) return;

	// recover the early event log
	t_listTemp=g_listHead->next;
	while (fscanf(f_earlyHandler,"%d",&source)!=EOF)
	{
		t_msgTemp=(struct MSG *)malloc(g_MSG_SIZE);

		fread(&(t_msgTemp->count),g_INT_SIZE,1,f_earlyHandler);
		fread(&(t_msgTemp->tag),g_INT_SIZE,1,f_earlyHandler);
		fread(&(t_msgTemp->typeValue),g_INT_SIZE,1,f_earlyHandler);
		fread(&(t_msgTemp->commValue),g_INT_SIZE,1,f_earlyHandler);
		Value2Comm(t_msgTemp);
		Value2Type(t_msgTemp);

		if (source!=t_listTemp->rank) t_listTemp=t_listTemp->next;
		t_msgTemp->pre=t_listTemp->msgTail[3];
		t_listTemp->msgTail[3]->next=t_msgTemp;
		t_listTemp->msgTail[3]=t_msgTemp;
	}

	fclose(f_earlyHandler);
	return;
}

void SaveLOG()
{
	int ierr,size;
	struct LIST *t_listTemp=g_listHead->next;
	struct LOG *t_logTemp;
	FILE *f_logHandler;

	f_logHandler=fopen(g_f_LogName,"wb");

	//write logged msg to file
	while (t_listTemp!=NULL)
	{
		t_logTemp=t_listTemp->logHead->next;
		while (t_logTemp!=NULL)
		{
			fwrite(&(t_listTemp->rank),g_INT_SIZE,1,f_logHandler);		
			fwrite(&(t_logTemp->count),g_INT_SIZE,1,f_logHandler);
			fwrite(&(t_logTemp->tag),g_INT_SIZE,1,f_logHandler);
			fwrite(&(t_logTemp->typeValue),g_INT_SIZE,1,f_logHandler);
			fwrite(&(t_logTemp->commValue),g_INT_SIZE,1,f_logHandler);
			
			ierr=MPI_Type_size(*(t_logTemp->pType),&size);
			fwrite(t_logTemp->buf,t_logTemp->count*size,1,f_logHandler);
	
			if (t_logTemp->next==NULL)
			{
				free(t_logTemp->buf);
				free(t_logTemp);
				t_listTemp->logTail=t_listTemp->logHead;
			}
			else {
				t_logTemp=t_logTemp->next;
				free(t_logTemp->pre->buf);
				free(t_logTemp->pre);
			}
		}
		t_listTemp=t_listTemp->next;
	}
	fclose(f_logHandler);
	return;
}

void RecoverLOG()
{
	int ierr,size,source;
	struct LIST *t_listTemp;
	struct LOG *t_logTemp;
	struct MSG *t_msgTemp;
	FILE *f_logHandler;

	f_logHandler=fopen(g_f_LogName,"wb");
	if (f_logHandler==NULL) return;

	// recover the logged msg and late event log
	t_listTemp=g_listHead->next;
	while (fscanf(f_logHandler,"%d",&(t_logTemp->source))!=EOF)
	{
		t_logTemp=(struct LOG *)malloc(g_LOG_SIZE);
		t_msgTemp=(struct MSG *)malloc(g_MSG_SIZE);

		fread(&(t_msgTemp->count),g_INT_SIZE,1,f_logHandler);
		fread(&(t_msgTemp->tag),g_INT_SIZE,1,f_logHandler);
		fread(&(t_msgTemp->typeValue),g_INT_SIZE,1,f_logHandler);
		fread(&(t_msgTemp->commValue),g_INT_SIZE,1,f_logHandler);
		Value2Comm(t_msgTemp);
		Value2Type(t_msgTemp);

		t_logTemp->count	=	t_msgTemp->count;
		t_logTemp->tag		=	t_msgTemp->tag;
		t_logTemp->typeValue=	t_msgTemp->typeValue;
		t_logTemp->commValue=	t_msgTemp->commValue;

		ierr=MPI_Type_size(*(t_logTemp->pType),&size);
		fread(t_logTemp->buf,t_logTemp->count*size,1,f_logHandler);

		if (t_logTemp->source!=t_listTemp->rank) t_listTemp=t_listTemp->next;
		t_logTemp->pre=t_listTemp->logTail;
		t_listTemp->logTail->next=t_logTemp;
		t_listTemp->logTail=t_logTemp;

		t_msgTemp->pre=t_listTemp->msgTail[2];
		t_listTemp->msgTail[2]->next=t_msgTemp;
		t_listTemp->msgTail[2]=t_msgTemp;
	}
	fclose(f_logHandler);
	return;
}

// for other MPI: comm,group,type -------------------------------------------------------------------------------
void SaveMPI()
{
	int ierr,flag,prop,seq,offset;
	struct DATATYPE *t_typeTemp=g_typeHead->next;
	struct COMM		*t_commTemp=g_commHead->next;
	struct GROUP	*t_groupTemp=g_groupHead->next;
	struct HEAP		*heapTemp;
	struct VAR		*varTemp;
	FILE *f_mpiHandler;

	f_mpiHandler=fopen(g_f_MpiName,"wb");

	// saving the datatype
	while (t_typeTemp!=NULL)
	{
		flag=-1;
		fwrite(&flag,g_INT_SIZE,1,f_mpiHandler);
		if (t_typeTemp->freeFlag==YES)
		{
			ierr=MPI_Type_free(t_typeTemp->pType);

			if (t_typeTemp->next!=NULL)
			{
				t_typeTemp->next->pre=t_typeTemp->pre;
				t_typeTemp->pre->next=t_typeTemp->next;
				t_typeTemp=t_typeTemp->next;
				free(t_typeTemp->pre);
			}
			else {
				g_typeTail=g_typeTail->pre;
				free(t_typeTemp);
			}
		}
		else {
			fwrite(&flag,g_INT_SIZE,1,f_mpiHandler);		
			fwrite(&(t_typeTemp->typeValue),g_INT_SIZE,1,f_mpiHandler);

			seq=1;
			heapTemp=g_heapHead->next;
			while (heapTemp!=NULL)
			{
				if ((heapTemp->pTop<=(void *)t_typeTemp->pType && heapTemp->pBottom>(void *)t_typeTemp->pType) ||
					(heapTemp->pTop>=(void *)t_typeTemp->pType && heapTemp->pBottom<(void *)t_typeTemp->pType)
					)	
				{
					prop=HEAP;
					offset=(void *)t_typeTemp->pType-heapTemp->pTop;
					fwrite(&prop,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&seq,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&offset,g_INT_SIZE,1,f_mpiHandler);	
					goto NEXT_TYPE;
				}
				heapTemp=heapTemp->next; 
				seq++;
			}

			seq=1;
			varTemp=g_varHead->next;
			while (varTemp!=NULL)
			{	
				if ((varTemp->pTop<=(void *)t_typeTemp->pType && varTemp->pBottom>(void *)t_typeTemp->pType) ||
					(varTemp->pTop>=(void *)t_typeTemp->pType && varTemp->pBottom<(void *)t_typeTemp->pType)
					)
				{
					prop=VAR;
					offset=(void *)t_typeTemp->pType-varTemp->pTop;
					fwrite(&prop,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&seq,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&offset,g_INT_SIZE,1,f_mpiHandler);	
					goto NEXT_TYPE;
				}
				varTemp=varTemp->next;
				seq++;
			}
NEXT_TYPE:	t_typeTemp=t_typeTemp->next;
		}
	}

	// saving the comm
	while (t_commTemp!=NULL)
	{
		flag=-2;
		if (t_commTemp->freeFlag==YES)
		{
			ierr=MPI_Comm_free(t_commTemp->pComm);

			if (t_commTemp->next!=NULL)
			{
				t_commTemp->next->pre=t_commTemp->pre;
				t_commTemp->pre->next=t_commTemp->next;
				t_commTemp=t_commTemp->next;
				free(t_commTemp->pre);
			}
			else {
				g_commTail=g_commTail->pre;
				free(t_commTemp);
			}
		}
		else {

			fwrite(&flag,g_INT_SIZE,1,f_mpiHandler);		
			fwrite(&(t_commTemp->commValue),g_INT_SIZE,1,f_mpiHandler);

			seq=1;
			heapTemp=g_heapHead->next;
			while (heapTemp!=NULL)
			{
				if ((heapTemp->pTop<=(void *)t_commTemp->pComm && heapTemp->pBottom>(void *)t_commTemp->pComm) ||
					(heapTemp->pTop>=(void *)t_commTemp->pComm && heapTemp->pBottom<(void *)t_commTemp->pComm)
					)	
				{
					prop=HEAP;
					offset=(void *)t_commTemp->pComm-heapTemp->pTop;
					fwrite(&prop,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&seq,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&offset,g_INT_SIZE,1,f_mpiHandler);	
					goto NEXT_COMM;
				}
				heapTemp=heapTemp->next; 
				seq++;
			}

			seq=1;
			varTemp=g_varHead->next;
			while (varTemp!=NULL)
			{	
				if ((varTemp->pTop<=(void *)t_commTemp->pComm && varTemp->pBottom>(void *)t_commTemp->pComm) ||
					(varTemp->pTop>=(void *)t_commTemp->pComm && varTemp->pBottom<(void *)t_commTemp->pComm)
					)
				{
					prop=VAR;
					offset=(void *)t_commTemp->pComm-varTemp->pTop;
					fwrite(&prop,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&seq,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&offset,g_INT_SIZE,1,f_mpiHandler);	
					goto NEXT_COMM;
				}
				varTemp=varTemp->next;
				seq++;
			}
NEXT_COMM:	t_commTemp=t_commTemp->next;
		}
	}

	// saving the group
	while (t_groupTemp!=NULL)
	{
		flag=-3;
		if (t_groupTemp->freeFlag==YES)
		{
			ierr=MPI_Group_free(t_groupTemp->pGroup);

			if (t_groupTemp->next!=NULL)
			{
				t_groupTemp->next->pre=t_groupTemp->pre;
				t_groupTemp->pre->next=t_groupTemp->next;
				t_groupTemp=t_groupTemp->next;
				free(t_groupTemp->pre);
			}
			else {
				g_groupTail=g_groupTail->pre;
				free(t_groupTemp);
			}
		}
		else {
			fwrite(&flag,g_INT_SIZE,1,f_mpiHandler);		

			seq=1;
			heapTemp=g_heapHead->next;
			while (heapTemp!=NULL)
			{
				if ((heapTemp->pTop<=(void *)t_groupTemp->pGroup && heapTemp->pBottom>(void *)t_groupTemp->pGroup) ||
					(heapTemp->pTop>=(void *)t_groupTemp->pGroup && heapTemp->pBottom<(void *)t_groupTemp->pGroup)
					)	
				{
					prop=HEAP;
					offset=(void *)t_groupTemp->pGroup-heapTemp->pTop;
					fwrite(&prop,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&seq,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&offset,g_INT_SIZE,1,f_mpiHandler);	
					goto NEXT_GROUP;
				}
				heapTemp=heapTemp->next; 
				seq++;
			}

			seq=1;
			varTemp=g_varHead->next;
			while (varTemp!=NULL)
			{	
				if ((varTemp->pTop<=(void *)t_groupTemp->pGroup && varTemp->pBottom>(void *)t_groupTemp->pGroup) ||
					(varTemp->pTop>=(void *)t_groupTemp->pGroup && varTemp->pBottom<(void *)t_groupTemp->pGroup)
					)
				{
					prop=VAR;
					offset=(void *)t_groupTemp->pGroup-varTemp->pTop;
					fwrite(&prop,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&seq,g_INT_SIZE,1,f_mpiHandler);	
					fwrite(&offset,g_INT_SIZE,1,f_mpiHandler);	
					goto NEXT_GROUP;
				}
				varTemp=varTemp->next;
				seq++;
			}
NEXT_GROUP:	t_groupTemp=t_groupTemp->next;
		}		
	}

	fclose(f_mpiHandler);
	return;
}

void RecoverMPI()
{
	int flag;
	struct DATATYPE *t_typeTemp;
	struct COMM		*t_commTemp;
	struct GROUP	*t_groupTemp;
	FILE *f_mpiHandler;

	f_mpiHandler=fopen(g_f_MpiName,"wb");
//	if (f_mpiHandler==NULL) return;

	while (fscanf(f_mpiHandler,"%d",&flag)!=EOF)
	{
		switch (flag)
		{
			case (0): {	// recover datatype
				t_typeTemp=(struct DATATYPE *)malloc(g_TYPE_SIZE);
				t_typeTemp->freeFlag=NO;
				fread(&(t_typeTemp->typeValue),g_INT_SIZE,1,f_mpiHandler);
				fread(t_typeTemp->pType,sizeof(MPI_Datatype),1,f_mpiHandler);

				t_typeTemp->pre=g_typeTail;
				g_typeTail->next=t_typeTemp;
				g_typeTail=t_typeTemp;
				break;
			}
			case (1): {	// recover comm
				t_commTemp=(struct COMM *)malloc(g_COMM_SIZE);
				t_commTemp->freeFlag=NO;
				fread(&(t_commTemp->commValue),g_INT_SIZE,1,f_mpiHandler);
				fread(t_commTemp->pComm,sizeof(MPI_Comm),1,f_mpiHandler);

				t_commTemp->pre=g_commTail;
				g_commTail->next=t_commTemp;
				g_commTail=t_commTemp;			
				break;
			}
			case (2): { // recover group
				t_groupTemp=(struct GROUP *)malloc(g_GROUP_SIZE);
				t_groupTemp->freeFlag=NO;
				fread(t_groupTemp->pGroup,sizeof(MPI_Group),1,f_mpiHandler);

				t_groupTemp->pre=g_groupTail;
				g_groupTail->next=t_groupTemp;
				g_groupTail=t_groupTemp;			
				break;
			}
		}
	}
	fclose(f_mpiHandler);
	return;
}

//------------------------------------------------------------------------------------------------------------
void OnCallEnter(int Tag,int fNum)
{
	struct FLOW *t_flowTemp=(struct FLOW *)malloc(g_FLOW_SIZE);

	if (g_RECOVER_FLAG==YES) return;

	t_flowTemp->Tag=Tag;
	t_flowTemp->fNum=fNum;
	t_flowTemp->ptrCount=0;
	t_flowTemp->varCount=0;
	t_flowTemp->next=NULL;

	g_flowTail->next=t_flowTemp;
	t_flowTemp->pre=g_flowTail;
	g_flowTail=t_flowTemp;

	return;
}

void OnCallReturn()
{
	struct FLOW *t_flowTemp=g_flowTail;

	OnReturnVar(t_flowTemp->varCount);		//remove the variable entry
	OnReturnPtr(t_flowTemp->ptrCount);		//remove the pointer entry

	g_flowTail=g_flowTail->pre;
	g_flowTail->next=NULL;
	/*
	while (t_flowTemp->subTail->pre!=NULL)
	{
		t_flowTemp->subTail=t_flowTemp->subTail->pre;
		free(t_flowTemp->subTail->next);
	}
	free(t_flowTemp->subHead);*/
	free(t_flowTemp);

	return;
}

void CKPT_Init()
{
	char *buf="-r";

	g_varHead	=	(struct VAR *)malloc(g_VAR_SIZE);
	g_heapHead	=	(struct HEAP *)malloc(g_HEAP_SIZE);
	g_flowHead	=	(struct FLOW *)malloc(g_FLOW_SIZE);
	g_funcHead	=	(struct FUNC *)malloc(g_FUNC_SIZE);
	g_listHead	=	(struct LIST *)malloc(g_LIST_SIZE);
	g_ptrHead	=	(struct POINTER *)malloc(g_POINTER_SIZE);
	g_struHead	=	(struct STRUCTS *)malloc(g_STRUCTS_SIZE);

	g_typeHead	=	(struct DATATYPE *)malloc(g_TYPE_SIZE);
	g_commHead	=	(struct COMM *)malloc(g_COMM_SIZE);
	g_groupHead	=	(struct GROUP *)malloc(g_GROUP_SIZE);

	g_varHead	->next	=	NULL;
	g_heapHead	->next	=	NULL;
	g_ptrHead	->next	=	NULL;
	g_struHead	->next	=	NULL;
	g_flowHead	->next	=	NULL;
	g_funcHead	->next	=	NULL;
	g_listHead	->next	=	NULL;

	g_typeHead	->next	=	NULL;
	g_commHead	->next	=	NULL;
	g_groupHead	->next	=	NULL;

	g_varTail	=	g_varHead;
	g_heapTail	=	g_heapHead;
	g_ptrTail	=	g_ptrHead;
	g_struTail	=	g_struHead;
	g_flowTail	=	g_flowHead;
	g_funcTail	=	g_funcHead;
	g_listTail	=	g_listHead;

	g_typeTail	=	g_typeHead;
	g_commTail	=	g_commHead;
	g_groupTail	=	g_groupHead;

	g_typeHead->typeValue=20;				// the user defined datatype starts from 21
	g_commHead->commValue=0;				// the user defined comm starts from 1

	return;
}
