
#include "mpi.h"
#include "libELC.h"

extern void SaveLOG();
extern void SaveMSG();

void Type2Value(struct MSG *t_msgTemp)
{
	struct DATATYPE *t_typeTemp=g_typeHead->next;

	if (*(t_msgTemp->pType)==g_MPI_CHAR) {
		t_msgTemp->typeValue=1;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_SHORT) {
		t_msgTemp->typeValue=2;
		return;
	}
	if (t_msgTemp->pType==&g_MPI_INT) {
		t_msgTemp->typeValue=3;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_LONG) {
		t_msgTemp->typeValue=4;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_UNSIGNED_CHAR) {
		t_msgTemp->typeValue=5;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_UNSIGNED_SHORT) {
		t_msgTemp->typeValue=6;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_UNSIGNED) {
		t_msgTemp->typeValue=7;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_UNSIGNED_LONG) {
		t_msgTemp->typeValue=8;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_FLOAT) {
		t_msgTemp->typeValue=9;
		return;
	}
	if (t_msgTemp->pType==&g_MPI_DOUBLE) {
		t_msgTemp->typeValue=10;
		return;
	}

	if (*(t_msgTemp->pType)==g_MPI_LONG_DOUBLE) {
		t_msgTemp->typeValue=11;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_BYTE) {
		t_msgTemp->typeValue=12;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_PACKED) {
		t_msgTemp->typeValue=13;
		return;
	}

	//datatype for reduction function
	if (*(t_msgTemp->pType)==g_MPI_FLOAT_INT) {
		t_msgTemp->typeValue=14;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_DOUBLE_INT) {
		t_msgTemp->typeValue=15;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_LONG_INT) {
		t_msgTemp->typeValue=16;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_2INT) {
		t_msgTemp->typeValue=17;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_SHORT_INT) {
		t_msgTemp->typeValue=18;
		return;
	}
	if (*(t_msgTemp->pType)==g_MPI_LONG_DOUBLE_INT) {
		t_msgTemp->typeValue=19;
		return;
	}
		
	//optional datatype
	if (*(t_msgTemp->pType)==g_MPI_LONG_LONG_INT) {
		t_msgTemp->typeValue=20;
		return;
	}

	//user defined datatype
	while (t_typeTemp!=NULL)
	{
		if (t_typeTemp->pType==t_msgTemp->pType)
		{
			t_msgTemp->typeValue=t_typeTemp->typeValue;
			break;
		}
		t_typeTemp=t_typeTemp->next;
	}
	return;
}

void Value2Type(struct MSG *t_msgTemp)
{
	struct DATATYPE *t_typeTemp=g_typeHead->next;

	switch (t_msgTemp->typeValue)
	{

		//elementray datatype
		case (1): {
			t_msgTemp->pType=&g_MPI_CHAR;
			break;
		}
		case (2): {
			t_msgTemp->pType=&g_MPI_SHORT;
			break;
		}
		case (3): {
			t_msgTemp->pType=&g_MPI_INT;
			break;
		}
		case (4): {
			t_msgTemp->pType=&g_MPI_LONG;
			break;
		}
		case (5): {
			t_msgTemp->pType=&g_MPI_UNSIGNED_CHAR;
			break;
		}
		case (6): {
			t_msgTemp->pType=&g_MPI_UNSIGNED_SHORT;
			break;
		}
		case (7): {
			t_msgTemp->pType=&g_MPI_UNSIGNED;
			break;
		}
		case (8): {
			t_msgTemp->pType=&g_MPI_UNSIGNED_LONG;
			break;
		}
		case (9): {
			t_msgTemp->pType=&g_MPI_FLOAT;
			break;
		}
		case (10): {
			t_msgTemp->pType=&g_MPI_DOUBLE;
			break;
		}
		case (11): {
			t_msgTemp->pType=&g_MPI_LONG_DOUBLE;
			break;
		}
		case (12): {
			t_msgTemp->pType=&g_MPI_BYTE;
			break;
		}
		case (13): {
			t_msgTemp->pType=&g_MPI_PACKED;
			break;
		}

		//datatype for reduction function
		case (14): {
			t_msgTemp->pType=&g_MPI_FLOAT_INT;
			break;
		}
		case (15): {
			t_msgTemp->pType=&g_MPI_DOUBLE_INT;
			break;
		}
		case (16): {
			t_msgTemp->pType=&g_MPI_LONG_INT;
			break;
		}
		case (17): {
			t_msgTemp->pType=&g_MPI_2INT;
			break;
		}
		case (18): {
			t_msgTemp->pType=&g_MPI_SHORT_INT;
			break;
		}
		case (19): {
			t_msgTemp->pType=&g_MPI_LONG_DOUBLE_INT;
			break;
		}
		
		//optional datatype
		case (20): {
			t_msgTemp->pType=&g_MPI_LONG_LONG_INT;
			break;
		}

		//user defined datatype
		default : {
			while (t_typeTemp!=NULL)
			{
				if (t_typeTemp->typeValue==t_msgTemp->typeValue)
				{
					t_msgTemp->pType=t_typeTemp->pType;
					break;
				}
				t_typeTemp=t_typeTemp->next;
			}
		}
	}
	return;
}

MPI_Datatype *Type2Ptr(MPI_Datatype datatype)
{
	struct DATATYPE *t_typeTemp=g_typeHead->next;

	if (datatype==g_MPI_CHAR)			return &g_MPI_CHAR;
	if (datatype==g_MPI_SHORT)			return &g_MPI_SHORT;
	if (datatype==g_MPI_INT)			return &g_MPI_INT;
	if (datatype==g_MPI_LONG)			return &g_MPI_LONG;
	if (datatype==g_MPI_UNSIGNED_CHAR)	return &g_MPI_UNSIGNED_CHAR;
	if (datatype==g_MPI_UNSIGNED_SHORT)	return &g_MPI_UNSIGNED_SHORT;
	if (datatype==g_MPI_UNSIGNED)		return &g_MPI_UNSIGNED;
	if (datatype==g_MPI_UNSIGNED_LONG)	return &g_MPI_UNSIGNED_LONG;
	if (datatype==g_MPI_FLOAT)			return &g_MPI_FLOAT;
	if (datatype==g_MPI_DOUBLE)			return &g_MPI_DOUBLE;
	if (datatype==g_MPI_LONG_DOUBLE)	return &g_MPI_LONG_DOUBLE;
	if (datatype==g_MPI_BYTE)			return &g_MPI_BYTE;
	if (datatype==g_MPI_PACKED)			return &g_MPI_PACKED;

	if (datatype==g_MPI_FLOAT_INT)		return &g_MPI_FLOAT_INT;
	if (datatype==g_MPI_DOUBLE_INT)		return &g_MPI_DOUBLE_INT;
	if (datatype==g_MPI_LONG_INT)		return &g_MPI_LONG_INT;
	if (datatype==g_MPI_2INT)			return &g_MPI_2INT;
	if (datatype==g_MPI_SHORT_INT)		return &g_MPI_SHORT_INT;
	if (datatype==g_MPI_LONG_DOUBLE_INT)return &g_MPI_LONG_DOUBLE_INT; 

	if (datatype==g_MPI_LONG_LONG_INT)	return &g_MPI_LONG_LONG_INT;

	while (t_typeTemp!=NULL)
	{
		if (*(t_typeTemp->pType)=datatype)	return t_typeTemp->pType;
		t_typeTemp=t_typeTemp->next;
	}
	return NULL;				// actually impossible
}

MPI_Comm *Comm2Ptr(MPI_Comm comm)
{
	struct COMM *t_commTemp=g_commHead->next;
	
	if (comm=MPI_COMM_WORLD) return &g_MPI_COMM_WORLD;

	while (t_commTemp!=NULL)
	{
		if (*(t_commTemp->pComm)==comm)	return t_commTemp->pComm;
		t_commTemp=t_commTemp->next;
		
	}
	return NULL;				// actually impossible
}

void Comm2Value(struct MSG *t_msgTemp)
{
	struct COMM *t_commTemp=g_commTail;

	if (*(t_msgTemp->pComm)==g_MPI_COMM_WORLD) t_msgTemp->commValue=0;

	while (t_commTemp!=g_commHead)
	{
		if (t_commTemp->pComm==t_msgTemp->pComm)
		{
			t_msgTemp->commValue=t_commTemp->commValue;
			break;
		}
		t_commTemp=t_commTemp->pre;
	}	
	return;
}

void Value2Comm(struct MSG *t_msgTemp)
{
	struct COMM *t_commTemp=g_commTail;

	switch (t_msgTemp->commValue)
	{
		case (0) : {
			t_msgTemp->pComm=&g_MPI_COMM_WORLD;
			break;
		}
		default : {
			while (t_commTemp!=g_commHead)
			{
				if (t_commTemp->commValue==t_msgTemp->commValue)
				{
					t_msgTemp->pComm=t_commTemp->pComm;
					break;
				}
			}
		}
	}
	return;
}

//--------------------------------------------------------------------------------------------------
// locating the corresponding nodes for the send/recv event log
struct LIST *seek_list(int rank)
{
	struct LIST *t_listTemp=g_listHead->next;
	
	while (rank!=t_listTemp->rank) t_listTemp=t_listTemp->next;
	return t_listTemp;
}

//create the send/recv event log
void insert_MSG(struct LIST *t_listTemp,int count,MPI_Datatype datatype,int tag,MPI_Comm comm,int mode,void *buf)
{
	struct MSG *t_msgTemp=(struct MSG *)malloc(g_MSG_SIZE);
	int size;

	MPI_Type_size(datatype,&size);

	t_msgTemp->count=count;
	t_msgTemp->tag=tag;
	t_msgTemp->pType=Type2Ptr(datatype);
	t_msgTemp->pComm=Comm2Ptr(comm);
	t_msgTemp->buf=(void *)malloc(count*size);
	memcpy(t_msgTemp->buf,buf,size*count);
	
	t_msgTemp->next=NULL;
	t_msgTemp->pre=t_listTemp->msgTail[mode];
	t_listTemp->msgTail[mode]->next=t_msgTemp;
	t_listTemp->msgTail[mode]=t_msgTemp;
	t_listTemp->count[mode]++;
}

//--------------------------------------------------------------------------------------------------------------
//initialize the send/recv log link-table
void setup_LIST()
{
	//global struct LIST *g_LIST;
	//global int g_COMM_SIZE,g_MYRANK;
	int i,ierr;
	struct LIST *t_listTemp;

	for (i=0;i<g_SIZE;i++)
	{
		t_listTemp=(struct LIST *)malloc(g_LIST_SIZE);

		t_listTemp->msgHead[0]=(struct MSG *)malloc(g_MSG_SIZE);
		t_listTemp->msgHead[1]=(struct MSG *)malloc(g_MSG_SIZE);
		t_listTemp->msgHead[2]=(struct MSG *)malloc(g_MSG_SIZE);
		t_listTemp->msgHead[3]=(struct MSG *)malloc(g_MSG_SIZE);

		t_listTemp->msgHead[0]->next=NULL;
		t_listTemp->msgHead[1]->next=NULL;
		t_listTemp->msgHead[2]->next=NULL;
		t_listTemp->msgHead[3]->next=NULL;

		t_listTemp->msgTail[0]=t_listTemp->msgHead[0];
		t_listTemp->msgTail[1]=t_listTemp->msgHead[1];
		t_listTemp->msgTail[2]=t_listTemp->msgHead[2];
		t_listTemp->msgTail[3]=t_listTemp->msgHead[3];

		t_listTemp->logHead=(struct LOG *)malloc(g_LIST_SIZE);
		t_listTemp->logHead->next=NULL;
		t_listTemp->logTail=t_listTemp->logHead;
		
		t_listTemp->rank=i;
		t_listTemp->next=NULL;
		t_listTemp->pre=g_listTail;
		g_listTail->next=t_listTemp;		
		g_listTail=t_listTemp;
	}
	g_listHead->pre=NULL;		//g_listHead points to process 0
}

void iden_msg(struct LIST *t_listTemp)
{
	struct MSG *t_sendTemp=t_listTemp->msgHead[0]->next;		// send ENV
	struct MSG *t_recvTemp=t_listTemp->msgHead[1]->next;		// recv ENV
	struct MSG *t_lateTemp=t_listTemp->msgHead[2]->next;
	struct MSG *t_earlyTemp=t_listTemp->msgHead[3]->next;
	struct MSG *t_Temp;
	struct LOG *t_logTemp,*t_logT;
	
	//delete the early msg in send event log
	while (t_sendTemp!=NULL)
	{
		t_earlyTemp=t_listTemp->msgHead[3]->next;
		if (t_earlyTemp==NULL) break;

		while (t_earlyTemp!=NULL)
		{
			if (t_sendTemp->tag==t_earlyTemp->tag &&
				t_sendTemp->pType==t_earlyTemp->pType &&
				t_sendTemp->pComm==t_earlyTemp->pComm
				)
			{
				//delete the early node
				if (t_earlyTemp->next!=NULL)
				{
					t_earlyTemp->pre->next=t_earlyTemp->next;
					t_earlyTemp->next->pre=t_earlyTemp->pre;
				}
				else {
					t_listTemp->msgTail[3]=t_earlyTemp->pre;
					t_listTemp->msgTail[3]=NULL;
				}
				free(t_Temp);
				//delete the send event log 
				if (t_sendTemp->next!=NULL)
				{
					t_sendTemp->pre->next=t_sendTemp->next;
					t_sendTemp->next->pre=t_sendTemp->pre;
				}
				else {
					t_listTemp->msgTail[0]=t_sendTemp->pre;
					t_listTemp->msgTail[0]=NULL;
				}
				t_Temp=t_sendTemp;
				t_sendTemp=t_sendTemp->pre;
				free(t_Temp);
				t_listTemp->count[0]--;

				break;
			}
			t_earlyTemp=t_earlyTemp->next;
		}
		t_sendTemp=t_sendTemp->next;
	}

	//delete the late msg in the recv event log
	while (t_recvTemp!=NULL)
	{
		t_lateTemp=t_listTemp->msgHead[2]->next;
		if (t_lateTemp==NULL) break;

		while (t_lateTemp!=NULL)
		{
			if (t_lateTemp->tag==t_recvTemp->tag &&
				t_lateTemp->pType==t_recvTemp->pType &&
				t_lateTemp->pComm==t_recvTemp->pComm
			)
			{
				//delete the late msg node
				if (t_lateTemp->next!=NULL)
				{
					t_lateTemp->pre->next=t_lateTemp->next;
					t_lateTemp->next->pre=t_lateTemp->pre;
				}
				else {
					t_listTemp->msgTail[2]=t_Temp->pre;
				}
				free(t_lateTemp);

				//delete the recv event log
				if (t_recvTemp->next!=NULL)
				{
					t_recvTemp->pre->next=t_recvTemp->next;
					t_recvTemp->next->pre=t_recvTemp->pre;
				}
				else {
					t_listTemp->msgTail[1]=t_recvTemp->pre;
				}
				t_Temp=t_recvTemp;
				t_recvTemp=t_recvTemp->pre;
				free(t_Temp);
				t_listTemp->count[1]--;

				break;
				}
			t_lateTemp=t_lateTemp->next;
		}
		t_recvTemp=t_recvTemp->next;
	}

	//delete the intra msg log
	t_sendTemp=t_listTemp->msgHead[0]->next;

	while (t_sendTemp!=NULL)
	{
		t_recvTemp=t_listTemp->msgHead[1]->next;
		if (t_recvTemp==NULL) break;
		while (t_recvTemp!=NULL)
		{
			if (t_sendTemp->tag==t_recvTemp->tag &&
				t_sendTemp->pType==t_recvTemp->pType &&
				t_sendTemp->pComm==t_recvTemp->pComm)
			{
				//delete the send event log
				if (t_sendTemp->next!=NULL)
				{
					t_sendTemp->pre->next=t_sendTemp->next;
					t_sendTemp->next->pre=t_sendTemp->pre;
				}
				else {
					t_listTemp->msgTail[0]=t_sendTemp->pre;
					t_listTemp->msgTail[0]->next=NULL;
				}
				t_Temp=t_sendTemp;
				t_sendTemp=t_sendTemp->pre;
				free(t_Temp);
				t_listTemp->count[0]--;

				//delete the recv event log
				if (t_recvTemp->next!=NULL)
				{
					t_recvTemp->pre->next=t_recvTemp->next;
					t_recvTemp->next->pre=t_recvTemp->pre;
				}
				else {
					t_listTemp->msgTail[1]=t_recvTemp->pre;
					t_listTemp->msgTail[1]->next=NULL;
				}
				free(t_recvTemp);
				t_listTemp->count[1]--;

				break;
			}
			t_recvTemp=t_recvTemp->next;
		}
		t_sendTemp=t_sendTemp->next;
	}

	/*
		msgHead[0]--late msg log
		msgHead[1]--early msg log
	*/
	
	//backup the late msg log
	t_listTemp->msgHead[2]->next=t_listTemp->msgHead[0]->next;
	t_listTemp->count[2]=t_listTemp->count[0];
	t_listTemp->msgHead[0]->next=NULL;
	t_listTemp->msgTail[0]=t_listTemp->msgHead[0];
	t_listTemp->count[0]=0;
	//backup the early msg log
	t_listTemp->msgHead[3]->next=t_listTemp->msgHead[1]->next;
	t_listTemp->count[3]=t_listTemp->count[1];
	t_listTemp->msgHead[1]->next=NULL;
	t_listTemp->msgTail[0]=t_listTemp->msgHead[0];
	t_listTemp->count[1]=0;

	// trim the logged msg
	t_logTemp=t_listTemp->logHead->next;
	while (t_logTemp!=NULL)
	{
		t_lateTemp=t_listTemp->msgHead[2]->next;
		while (t_Temp!=NULL)
		{
			if (t_lateTemp->tag==t_logTemp->tag &&
	    		t_lateTemp->pType==t_logTemp->pType &&
				t_lateTemp->pComm==t_logTemp->pComm)
			{
				// delete the logged msg
				if (t_logTemp->next!=NULL)
				{
					t_logTemp->pre->next=t_logTemp->next;
					t_logTemp->next->pre=t_logTemp->pre;
				}
				else {
					t_listTemp->logTail=t_logTemp->pre;
				}
				t_logT=t_logTemp;
				t_logTemp=t_logTemp->pre;
				free(t_logT->buf);
				free(t_logT);
				t_listTemp->log_counter--;				

				// delete the late env
				if (t_lateTemp->next!=NULL)
				{
					t_lateTemp->pre->next=t_lateTemp->next;
					t_lateTemp->next->pre=t_lateTemp->pre;
				}
				else {
					t_listTemp->msgTail[2]=t_lateTemp->pre;
				}
				free(t_lateTemp);
				t_listTemp->count[2]--;
				break;
			}
			t_lateTemp=t_lateTemp->next;
		}
		t_logTemp=t_logTemp->next;
	}

	return;
}

void log_msg(void *buf,int count,MPI_Datatype datatype,int source,int tag,MPI_Comm comm,struct LIST *t_listTemp)
{
	int size,i;
	struct MSG *t_msgTemp=t_listTemp->msgHead[2]->next;
	struct LOG *t_logTemp=(struct LOG *)malloc(g_LOG_SIZE);

	MPI_Type_size(datatype,&size);
	t_logTemp->buf=(void *)malloc(size*count);
	memcpy(t_logTemp->buf,buf,count*size);
	t_logTemp->count=count;
	t_logTemp->source=source;
	t_logTemp->tag=tag;
	t_logTemp->pType=&datatype;
	t_logTemp->pComm=&comm;
	
	t_logTemp->pre=t_listTemp->logTail;
	t_listTemp->logTail->next=t_logTemp;
	t_listTemp->logTail=t_logTemp;
	t_listTemp->log_counter++;
	
	if (t_msgTemp==NULL)
	{
		t_listTemp->flag==LOG_DONE;
		if (++g_LOG_COUNT==g_SIZE-1) 
		{
			g_CKPT_FLAG=NO;
			SaveLOG();
		}
		//COPY THE LATE MSG LOG TO msgHead[2]
		t_logTemp=t_listTemp->logHead->next;
		for (i=0;i<t_listTemp->log_counter-1;i++)
		{
			t_msgTemp=(struct MSG *)malloc(g_MSG_SIZE);
			t_msgTemp->tag=t_logTemp->tag;
			t_msgTemp->pType=t_logTemp->pType;
			t_msgTemp->pComm=t_logTemp->pComm;
			t_msgTemp->count=t_logTemp->count;

			t_msgTemp->pre=t_listTemp->msgTail[2];
			t_listTemp->msgTail[2]->next=t_msgTemp;
			t_listTemp->msgTail[2]=t_msgTemp;
		}
	}
	return;
}

void OnCKPT()
{
	int i;
	struct LIST *t_listTemp=g_listHead->next;
	struct MSG *t_msgTemp;
	MPI_Status t_status;

	for (i=0;i<g_SIZE;i++)
	{
		if (t_listTemp->rank!=g_MYRANK)
		{
			// send out the envelop
			t_msgTemp=t_listTemp->msgHead[0]->next;
			t_listTemp->msgHead[0]->next=NULL;
			t_listTemp->msgTail[0]=t_listTemp->msgHead[0];
		
			MPI_Send(&(t_listTemp->count[0]),1,MPI_INT,i,CKPT_TAG,CKPT_COMM);
			while (t_msgTemp!=NULL)
			{
				Type2Value(t_msgTemp);										// maps the datatype to an integer value
				Comm2Value(t_msgTemp);										// maps the comm to an integer value
				MPI_Send(t_msgTemp,1,MPI_MSG,i,CKPT_TAG,CKPT_COMM);			// pre-defined MPI_MSG
				if (t_msgTemp->next==NULL)
				{
					free(t_msgTemp);
					t_msgTemp=NULL;
				}
				else {
					t_msgTemp=t_msgTemp->next;
					free(t_msgTemp->pre);
				}
			}
		}
		t_listTemp=t_listTemp->next;
	}
	return;
}

void probe_others()
{
	int i;
	int flag=YES;
	struct LIST *t_listTemp;
	struct MSG *t_msgTemp;
	int count;
	MPI_Status t_status;

	while (flag==YES)
	{
		MPI_Iprobe(MPI_ANY_SOURCE,CKPT_TAG,CKPT_COMM,&flag,&t_status);
		if (flag==NO) break;
		MPI_Recv(&count,1,MPI_INT,t_status.MPI_SOURCE,CKPT_TAG,CKPT_COMM,&t_status);

		t_listTemp=seek_list(t_status.MPI_SOURCE);
		t_listTemp->count[0]=count;
//		printf("%d recv %d env from %d\n",g_MYRANK,count,t_listTemp->rank);	

		for (i=0;i<t_listTemp->count[0];i++)
		{
			t_msgTemp=(struct MSG *)malloc(g_MSG_SIZE);

			MPI_Recv(t_msgTemp,1,MPI_MSG,t_status.MPI_SOURCE,CKPT_TAG,CKPT_COMM,&t_status);
			Value2Type(t_msgTemp);
			Value2Comm(t_msgTemp);
			
			t_msgTemp->next=NULL;
			t_msgTemp->pre=t_listTemp->msgTail[0];
			t_listTemp->msgTail[0]->next=t_msgTemp;
			t_listTemp->msgTail[0]=t_msgTemp;
		}
		t_listTemp->flag=ENV_DONE;
		iden_msg(t_listTemp);
		if (++g_ENV_COUNT==g_SIZE-1) SaveMSG();

	}
	return;
}

void try_early(struct LIST * t_listTemp,int count,MPI_Datatype datatype,int source,int tag,MPI_Comm comm)
{
	int ierr,size;
	struct MSG *t_msgTemp=t_listTemp->msgHead[3]->next;
	MPI_Status t_status;
	void *p_buf;

	while (t_msgTemp!=NULL)
	{
		if (t_msgTemp->count==count &&
			t_msgTemp->tag==tag &&
			*(t_msgTemp->pType)==datatype &&	
			*(t_msgTemp->pComm)==comm)
		{
			ierr=MPI_Type_size(datatype,&size);
			p_buf=(void *)malloc(size*count);
			ierr=MPI_Recv(p_buf,count,datatype,source,tag,comm,&t_status);
			free(p_buf);

			if (t_msgTemp->next!=NULL)
			{
				t_msgTemp->pre->next=t_msgTemp->next;
				t_msgTemp->next->pre=t_msgTemp->pre;
			}
			else {
				t_listTemp->msgTail[2]=t_msgTemp->pre;
				t_listTemp->msgTail[2]->next=NULL;
			}
			free(t_msgTemp);
			break;
		}
		t_msgTemp=t_msgTemp->next;
	}
	return;
}


int try_log(struct LIST *t_listTemp,int count,MPI_Datatype datatype,int tag,MPI_Comm comm,void *buf)
{
	struct LOG *t_logTemp=t_listTemp->logHead->next;
	int size=NO;

	while (t_logTemp!=NULL)
	{
		if (t_logTemp->count==count &&
			t_logTemp->tag==tag &&
			*(t_logTemp->pType)==datatype &&
			*(t_logTemp->pComm)==comm )
		{
			//feed the buf
			MPI_Type_size(datatype,&size);
			memcpy(buf,t_logTemp->buf,count*size);
			//delete the matching log
			if (t_logTemp->next!=NULL)
			{
				t_logTemp->pre->next=t_logTemp->next;
				t_logTemp->next->pre=t_logTemp->pre;
			}
			else {
				t_listTemp->logTail=t_logTemp->pre;
				t_listTemp->logTail->next=NULL;
			}
			free(t_logTemp->buf);
			free(t_logTemp);
			t_listTemp->log_counter--;
			return size;
		}
		t_logTemp=t_logTemp->next;
	}
	return size;  //0-no log; >0-found log
}



int seek_late_msg(int count,MPI_Datatype datatype,int tag,MPI_Comm comm,struct LIST *t_listTemp)
{
	struct MSG *t_msgTemp=t_listTemp->msgHead[2]->next;	//msgHead[2]--late msg

	while (t_msgTemp!=NULL)
	{
		if (t_msgTemp->count==count &&
			t_msgTemp->tag==tag &&
			*(t_msgTemp->pType)==datatype &&
			*(t_msgTemp->pComm)==comm)
		{
			//delete the late msg log
			if (t_msgTemp->next!=NULL)
			{
				t_msgTemp->pre->next=t_msgTemp->next;
				t_msgTemp->next->pre=t_msgTemp->pre;
			}
			else {
				t_listTemp->msgTail[2]=t_msgTemp->pre;
				t_listTemp->msgTail[2]->next=NULL;
			}
			free(t_msgTemp);
			return YES;
		}
		t_msgTemp=t_msgTemp->next;
	}
	return NO;	//this msg is not late msg
}

// ---------------------------------------------------------------------------------------------------------
/*
int ban_early_send_onRecover(struct LIST *t_listTemp,int count,MPI_Datatype datatype,int source,int tag,MPI_Comm comm)
{
	struct MSG *t_msgTemp=t_listTemp->msgHead[3];
	int size;
	void *buf;
	MPI_Status t_status;

	while (t_msgTemp!=NULL)
	{
		if (t_msgTemp->count=count &&
			t_msgTemp->pType==&datatype &&
			t_msgTemp->tag==tag &&
			t_msgTemp->pComm==&comm)
		{
			//discard the early msg
			MPI_Type_size(datatype,&size);
			buf=(void *)calloc(count,size);
			MPI_Recv(&buf,count,datatype,source,tag,comm,&t_status);
			free(buf);
			//disable the mathing lastRecv
			count=-1;
			
			if (t_msgTemp->next!=NULL)
			{
				t_msgTemp->pre->next=t_msgTemp->next;
				t_msgTemp->next->pre=t_msgTemp->pre;
			}
			else {
				t_listTemp->msgTail[3]=t_msgTemp->pre;
			}
			free(t_msgTemp);
			t_listTemp->count[3]--;
			return count;
		}
	}
	return count; //if found, count<0
}
*/
