
#include "mpi.h"
#include "libELC.h"
//------------------------------------------------------------------------------------------------------------
// for variable

void OnVarDef(int size, void *pTop, int count)
{
	struct VAR *varTemp=(struct VAR *)malloc(g_VAR_SIZE);;

	varTemp->size=size;
	varTemp->count=count;
	varTemp->pTop=pTop;
	varTemp->next=NULL;

	g_varTail->next=varTemp;
	varTemp->pre=g_varTail;
	g_varTail=varTemp;

	g_flowTail->varCount++;
	return;
}

void OnReturnVar(int count)
{
	struct VAR *t_varTemp;
	
	while (count>0)
	{
		t_varTemp=g_varTail;
		g_varTail=g_varTail->pre;

		free(t_varTemp);
		count--;
	}
	g_varTail->next=NULL;
	return;
}

//-----------------------------------------------------------------------------------------------------------
// for structs

void OnStructDef(STRUCT name,int size,int ptrCount,int ptrDisp[],int strCount, int strDisp[],STRUCT strName[])
{  
  int i,j;
  int *t_ptrDisp;
  struct STRUCTS *struTemp,*struChild;

  struTemp=(struct STRUCTS *)malloc(g_STRUCTS_SIZE);

  memcpy(struTemp->name,name,20);
  struTemp->size=size;
  struTemp->ptrCount=ptrCount;
  struTemp->ptrDisp=ptrDisp;

  for (i=0;i<strCount;i++)
  {
	  struChild=g_struHead->next;
	 
	  while (struChild!=NULL && !strcmp((char *)struChild->name,(char *)strName+i))
	  {
		struChild=struChild->next;
	  }
	  // append the ptrCount to the existing
	  t_ptrDisp=malloc(g_INT_SIZE*(struTemp->ptrCount+struChild->ptrCount));
	  memcpy(t_ptrDisp,struTemp->ptrDisp,g_INT_SIZE*struTemp->ptrCount);
	  memcpy(t_ptrDisp+struTemp->ptrCount,struChild->ptrDisp,g_INT_SIZE*struChild->ptrCount);
  	  struTemp->ptrCount+=struChild->ptrCount;
	  // relocate the disp
	  for (j=0;j<struChild->ptrCount;j++)
	  {
		  *(t_ptrDisp+struTemp->ptrCount+j)+=*(strDisp+i);
	  }
	  
	  free(struTemp->ptrDisp);
	  struTemp->ptrDisp=t_ptrDisp;
	  t_ptrDisp=NULL;
  }

  struTemp->pre=g_struTail;
  g_struTail->next=struTemp;
  g_struTail=struTemp;
  return;
}

void OnStructVarDef(STRUCT name,void *pTop,int count)
{
   int i;
   struct STRUCTS *struTemp=g_struHead->next;

   // find the matchin structure definition
   while (struTemp!=NULL && !strcmp((char *)&struTemp->name,(char *)name)){
      struTemp=struTemp->next;
   }

   if (struTemp==NULL)   return;	// if not found, error --> quit
	
   while (count--)
   {
	   OnVarDef(struTemp->size,pTop,count);				// push the structure mem block to the VAR list
	
	   for (i=0;i<struTemp->ptrCount;i++)
	   {
		   OnPtrDef(pTop+*(struTemp->ptrDisp+i),1);		// push each inline pointer to PTR list
	   }
   }
   return;
}

//-------------------------------------------------------------------------------------------------------------
// for pointer

void OnPtrDef(void *ptr,int count)
{
	int i=0;
	struct POINTER *ptrTemp=(struct POINTER *)malloc(g_POINTER_SIZE);

	while (i<count)
	{
		ptrTemp->pTarget=ptr+g_PTR_SIZE*i;
		ptrTemp->prop=NULLS;
		ptrTemp->next=NULL;

		ptrTemp->pre=g_ptrTail;
		g_ptrTail->next=ptrTemp;
		g_ptrTail=ptrTemp;

		g_flowTail->ptrCount++;
		i++;
	}
	return;
}

void OnReturnPtr(int count)
{
	struct POINTER *t_ptrTemp;

	while (count>0)
	{
		t_ptrTemp=g_ptrTail;
		g_ptrTail=g_ptrTail->pre;

		free(t_ptrTemp);
		count--;
	}
	g_ptrTail->next=NULL;
	return;
}

void OnPtrCKPT()
{
	struct POINTER *ptrTemp=g_ptrHead->next;
	
	while (ptrTemp!=NULL)
	{
		PtrSeek(ptrTemp);

		ptrTemp=ptrTemp->next;
	}
	return;
}

void PtrSeek(struct POINTER *ptrT)
{
	int seq;
	struct POINTER	*ptrTemp=g_ptrHead->next;
	struct HEAP		*heapTemp=g_heapHead->next;
	struct VAR		*varTemp=g_varHead->next;
	struct FUNC		*addrTemp=g_funcHead->next;

	seq=1;
	while (heapTemp!=NULL)
	{
		if ((heapTemp->pTop<=*(ptrT->pTarget) && heapTemp->pTop+heapTemp->size-1>*(ptrT->pTarget)) ||
			(heapTemp->pTop>=*(ptrT->pTarget) && heapTemp->pTop+heapTemp->size-1<*(ptrT->pTarget))
			)
		{
			ptrT->prop=HEAP;
			ptrT->seq=seq;
			ptrT->offset=*(ptrT->pTarget)-heapTemp->pTop;

			return;
		}
		heapTemp=heapTemp->next; 
		seq++;
	}
//	if (heapTemp!=NULL) { return; }
	seq=1;
	while (varTemp!=NULL)
	{	
		if ((varTemp->pTop<=ptrT->pTarget && varTemp->pBottom>ptrT->pTarget) ||
			(varTemp->pTop>=ptrT->pTarget && varTemp->pBottom<ptrT->pTarget)
		)
		{
			ptrT->prop=VAR;
			ptrT->seq=seq;
			ptrT->offset=*(ptrT->pTarget)-varTemp->pTop;

			return;
		}
		varTemp=varTemp->next;
		seq++;
	}
//	if (varTemp!=NULL){ return;	}
	seq=1;
	while (addrTemp!=NULL)
	{
		if (addrTemp->func==ptrT->pTarget)
		{
			ptrT->prop=FUNC;
			ptrT->seq=seq;
			ptrT->offset=0;

			return;
		}
		addrTemp=addrTemp->next;
		seq++;
	}

    seq=1;
	while (ptrTemp!=NULL)
	{
		if (ptrTemp->pTarget==*(ptrT->pTarget))
		{
			ptrT->prop=PTR;
			ptrT->seq=seq;
			ptrT->offset=0;

			return;
		}
		ptrTemp=ptrTemp->next;
		seq++;
	}
}

//--------------------------------------------------------------------------------------------------------------
// for function pointer

void OnFuncDef(void *func)
{
	struct FUNC *funcTemp=(struct FUNC *)malloc(g_FUNC_SIZE);

	if (g_funcHead->next==NULL)
	{
		funcTemp->seq=1;
	}
	else {
		funcTemp->seq=g_funcTail->seq+1;
	}
	funcTemp->func=func;
	funcTemp->next=NULL;

	funcTemp->pre=g_funcTail;
	g_funcTail->next=funcTemp;
	g_funcTail=funcTemp;
	return;
}

/*
void OnStructVarDef(char *pName,void *pTop,int count)
{
   int i,disp,type_size;
   struct STRUCTS *struTemp=struHead->next;
   struct VAR *varTemp=(struct VAR *)malloc(g_VAR_SIZE);
   struct POINTER *ptrTemp=(struct POINTER *)malloc(g_POINTER_SIZE);
   struct STRUCT_VAR *stru_varTemp;

   //search the struct definition
   while (struTemp!=NULL && struTemp->pName!=pStructName){
      struTemp=struTemp->next;
   }

   if (struTemp==NULL){return;}
   while (count--)
   {
		//create new node for struct var
        stru_varTemp=(struct STRUCT_VAR *)malloc(g_STRUCT_VAR_SIZE);
		stru_varTemp->pre=g_struct_varTail;
		g_struct_varTail->next=stru_varTemp;
		g_struct_varTail=struc_varTemp;
		if (g_struct_varHead->next==NULL)
		{
			g_struct_varHead->next=g_struct_varTail;
		}
		
	   // fill the struct var
	   for (i=0;i<struTemp->count;i++)
	   {
		     switch (*(struTemp->pType+i))
		     {
				case (POINTER):
		     
					ptrTemp->pTarget=pTop+*(struTemp->pDisp+i);

					if (struct_varTemp->ptrHead!=NULL)
					{
						ptrTemp->pre=struct_varTemp->ptrHead;
					}
					struct_varTemp->ptrHead->next=ptrTemp;
					struct_varTemp->ptrHead=ptrTemp;

					break;
				case (STRUCTS): 
					
					break;
				default:
					type_size=cal_type_size(*(struTemp->pType+i));
	
					varTemp->datatype=*(struTemp->pType+i);
					varTemp->count=*(struTemp->pLength+i);
					varTemp->pTop=pTop+*(strutemp->pDisp+i);
					varTemp->pBottom=pTop+type_size*(*(struTemp->pLength+i))-1;
	
					//෴, ͷβ
					if (struct_varTemp->varHead!=NULL)
					{
						struct_varTemp->varHead->next=varTemp;
					}
					varTemp->pre=struct_varTemp->varHead;
					struct_varTemp->varHead=varTemp;
			}
	   }
   }
   g_flowTail->structCount+=count;

   return;
}
*/



//--------------------------------------------------------------------------------------------------
//for typedef

void OnTypePtrDef(char *pTypePtrName)
{
	strcat(g_TYPE_PTR_NAME,pTypePtrName);
}

void OnTypeOtherDef(char pOldName[STRUCT_NAME_20],char pNewName[STRUCT_NAME_20])
{
	struct STRUCTS *t_struTemp=g_struHead->next;

	while (t_struTemp!=NULL)
	{
		if (strstr(t_struTemp->pAlias,pOldName)!=NULL)
		{
			strcat(t_struTemp->pAlias,"#");
			strcat(t_struTemp->pAlias,pNewName);
			return;
		}
		t_struTemp=t_struTemp->next;
	}
	return;
}

void OnTypeVarDef(char pTypeName[STRUCT_NAME_20],int size,void *pTop,int count)
{
	struct STRUCTS	*t_struTemp=g_struHead->next;
	char *pAlias;

	while (t_struTemp!=NULL)
	{
		pAlias=t_struTemp->pAlias;
		// found the string in struct's aliases
		if (strstr(pAlias,pTypeName)!=NULL)
		{
			OnStructVarDef(t_struTemp->name,pTop,count*size/t_struTemp->size);
			return;
		}
		t_struTemp=t_struTemp->next;
	}

	// found the string in the pointer's string
	if (strstr(g_TYPE_PTR_NAME,pTypeName)!=NULL)
	{
		OnPtrDef(pTop,count*size/g_PTR_SIZE);	// already be &ptr
		return;
	}

	// otherwise, it's a common variable
	OnVarDef(size,pTop,count);
	return;
}
